<!-- Beispiel-PHP-Script fr die NettalkIRCD Statistik - (c)2004 by Nicolas Kruse -->
<?PHP

define ("VALUE_SIZE", 32);
define ("LINE_SIZE", VALUE_SIZE * 2);
define ("VALUE_COUNT", 512);

define ("FILE_PATH", "Chanstat.dat"); // <-----**Hier den Pfad festlegen

//---- **Statistik ffnen
setupdstat(FILE_PATH, "#".@$_GET['channel']);

function setupdstat($filepath, $channel)
{
	$fs = filesize($filepath);
	$fp = fopen ($filepath,"r");
	
	if (strlen($channel) == 1 || $channel == "#list")
	{
		$counti = 0;
		for ($i = 0; $i < $fs; $i = $i + LINE_SIZE * VALUE_COUNT)
		{
			fseek($fp, $i);
			$dat = fread ($fp, VALUE_SIZE);
			$statarr[$counti] = rtrim($dat);
			$counti = $counti + 1;
		}
		sort($statarr);
		drawlist($statarr);
	}
	else
	{
		for ($i = 0; $i < $fs; $i = $i + LINE_SIZE * VALUE_COUNT)
		{
			fseek($fp, $i);
			$dat = fread($fp, VALUE_SIZE);
			if(strtoupper(rtrim($dat)) == strtoupper($channel)) break;
		}
		if ($i+2 < $fs)
		{
			$counti = 0;
			$maxtwc = 0;
			$maxtlc = 0;
			for ($i2 = $i + LINE_SIZE; $i + (VALUE_COUNT - 1) * LINE_SIZE; $i2 = $i2 + LINE_SIZE)
			{
				fseek($fp, $i2);
				$dat = fread($fp, VALUE_SIZE);
				if(ord(substr($dat, 0, 1)) == 0) break;
				$tempnick = rtrim($dat);
				$dat = fread($fp, VALUE_SIZE);
				if (ord(substr($dat, 0, 1)) == 0) break;
			    $statarr[0][$counti] = rtrim(substr($dat,0,16));
			    $statarr[1][$counti] = rtrim(substr($dat,16,16));
			    $statarr[2][$counti] = $tempnick;
			    if ($statarr[0][$counti] > $maxtwc) $maxtwc = $statarr[0][$counti];
			    if ($statarr[1][$counti] > $maxtlc) $maxtlc = $statarr[1][$counti];
			    $counti = $counti + 1;
			}
			
			$maxtlc = $maxtwc; // <----- **Optional
			
			array_multisort ($statarr[0], SORT_NUMERIC, SORT_DESC, $statarr[1], SORT_NUMERIC, SORT_DESC, $statarr[2], SORT_STRING, SORT_ASC);
			drawstat($statarr, $maxtwc, $maxtlc, $channel);
		}
		else
		{
			echo("<h1>Chat-Statistik</h1><br>Keine Eintrge vorhanden");
		}
	}
	fclose($fp);
}

//*---------------------------------- ** Ausgabe der Raumliste ** ----------------------------------*

function drawlist($channels)
{
?>
	<h1>Chat-Statistik</h1>
	<br>
	Verfgbaren Statistiken:
	<ul>
<?
	for($i = 0; $i < count($channels); $i = $i + 1)
	{
?>
	<li><a href="Stat2.php?channel=<? echo(substr($channels[$i],1)); ?>" ><? echo($channels[$i]); ?></a></li>
<?
	}
?>
	</ul>
<?
}


//*---------------------------------- ** Ausgabe der Statistik ** ----------------------------------*

function drawstat($users, $maxwc, $maxlc, $channel)
{
	
?>
	<h1>Statistik von <? echo($channel); ?></h1>
	<table border="0" width="100%" cellpadding="0" cellspacing="0">
	<tr>
		<td height="28" align="right" colspan="8" background="images/ststdivline.gif"></td>
	</tr>
<?
	
	for($i = 0; $i < count($users[0]); $i = $i + 1)
	{
?>
	<tr>
		<td width="150" align="right" rowspan="2" valign="top">
		<p align="left"><? echo($i+1).". &nbsp;".$users[2][$i]; ?></td>
		<td colspan="4" align="right">
		<table border="0" width="<? echo($users[0][$i] / $maxwc * 100); ?>%" cellspacing="0" cellpadding="0" height="28">
			<tr>
				<td background="images/greenl.gif" width="10"></td>
				<td background="images/greenm.gif">&nbsp;</td>
				<td background="images/greenr.gif" width="10"></td>
			</tr>
		</table>
		</td>
		<td width="60" align="right"><? echo($users[0][$i]); ?></td>

	</tr>
	<tr>
		<td colspan="4" align="right">
		<table border="0" width="<? echo($users[1][$i] / $maxlc * 100); ?>%" cellspacing="0" cellpadding="0" height="28">
			<tr>
				<td background="images/bluel.gif" width="10"></td>
				<td background="images/bluem.gif">&nbsp;</td>
				<td background="images/bluer.gif" width="10"></td>
			</tr>
		</table>
		</td>
		<td width="60" align="right"><? echo($users[1][$i]); ?></td>
	</tr>
	<tr>
		<td height="28" align="right" colspan="8" background="images/ststdivline.gif"></td>
	</tr>
<?
		if($i+2 > 100) break;
	}
?>
	</table>
	<br>
	<table border="0" width="150" cellspacing="0" cellpadding="0" height="28">
		<tr>
			<td background="images/greenl.gif" width="10"></td>
			<td background="images/greenm.gif">&nbsp;</td>
			<td background="images/greenr.gif" width="10"></td>
			<td width="100"> &nbsp;Wrter</td>
		</tr>
	</table>
	<table border="0" width="150" cellspacing="0" cellpadding="0" height="28">
		<tr>
			<td background="images/bluel.gif" width="10"></td>
			<td background="images/bluem.gif">&nbsp;</td>
			<td background="images/bluer.gif" width="10"></td>
			<td width="100"> &nbsp;Zeilen</td>
		</tr>
	</table>
	<br>
	<a href="Stat2.php?channel=list">Liste mit allen verfgbaren Statistiken</a>
<?
}
//*----------------------------------------------------------------------------------------*
?>